function bound_te_boot = bound_te_boot(data, y_index, delta_index, x_pt, n, bw, boot, an) 

di = size(y_index,1) ;

fun_boot = zeros(di,di) ;
fun_est = zeros(di,di); 


for i = 1:di
    for j = 1:di 
        
        f_est_mat = f_est(data, y_index(i,1), delta_index(j,1), x_pt, bw) ;         
        f_boot_est_mat = f_boot_est(data, y_index(i,1), delta_index(j,1), x_pt, bw, boot) ;    
        
        fun_est(i,j) = f_est_mat(:,1) - f_est_mat(:,2) ;        
        fun_boot(i,j) = f_boot_est_mat(:,1) - f_boot_est_mat(:,2) ;
         
        
    end 
end

%% Simulating lower bound

fun_est_sup_pert_mat = kron(ones(di,1), max(fun_est) - an) ;

select = (fun_est - fun_est_sup_pert_mat >= 0 )' ; 

h_fun = sqrt(n*bw)*fun_boot'; 

arg1_mat = [] ; 
arg2_mat = [] ; 


for i = 1:di 
    
    h_col = h_fun(:,i) ; 
    %mh_col = -h_col ; 
    temp1 = h_col(select(:,i) == 1) ; 
    temp2 = -h_col(select(:,i) == 1) ;
    
    arg1_mat = [arg1_mat; max(temp1)] ;
    arg2_mat = [arg2_mat; min(temp2)] ;
    
end

arg1 = max(arg1_mat) ; 
arg2 = max(arg2_mat) ;

lambda_lower = max(arg1, arg2) ; 


%% Simulating upper bound

fun_est_2 = fun_est + 1 ;
fun_est_inf_pert_mat = kron(ones(di,1),min(fun_est_2) + an ) ;


select2 = (fun_est_2 - fun_est_inf_pert_mat <= 0)' ;

h_fun_2 = h_fun + 1; 

arg3_mat = []; 
arg4_mat = []; 

for i = 1:di 
    
    h_col2 = h_fun_2(:,i) ; 
    %mh_col = -h_col ; 
    temp3 = -h_col2(select2(:,i) == 1) ; 
    temp4 = h_col2(select2(:,i) == 1) ;
    
    arg3_mat = [arg3_mat; max(temp3)] ;
    arg4_mat = [arg4_mat; min(temp4)] ; 
    
end

arg3 = max(arg3_mat) ; 
arg4 = max(arg4_mat) ;


lambda_upper = max(arg3, arg4) ;  


%bound_te_boot = lambda_lower ; 
bound_te_boot = [lambda_lower, lambda_upper] ;