function true_bound = true_bound(delta_pt, mu1, mu0, sigma1, sigma0) 

s = delta_pt - (mu1 - mu0) ;

if sigma1 == sigma0 
    
    sigma = sigma1; 
    
    if s <= 0 
        
        true_lower = 0 ; 
        true_upper = 2* normcdf(s./2*sigma) ;
        
    end
    
    if s >= 0
        
        true_lower = 2* normcdf(s./2*sigma) - 1; 
        true_upper = 1 ; 
        
    end 
    
else 
    
    t = sqrt(s.^2 + (sigma1^2 - sigma0^2)*log(sigma1/sigma0)); 
    
    fun1 = (sigma1*s - sigma0*t) / (sigma1^2 - sigma0^2)  ; 
    fun2 = (sigma1*t - sigma0*s) / (sigma1^2 - sigma0^2) ; 
    
    true_lower = normcdf(fun1, 0,1) + normcdf(fun2, 0,1) - 1; 
    
    fun3 = (sigma1*s + sigma0*t) / (sigma1^2 - sigma0^2)  ; 
    fun4 = (sigma1*t + sigma0*s) / (sigma1^2 - sigma0^2) ; 
    
    true_upper = normcdf(fun3,0,1) - normcdf(fun4,0,1) + 1; 
    
end


true_bound = [true_lower, true_upper];